import sys
import gobject
import gtk
import goocanvas

from custom_objects import CustomItem



class GeneratorItem(CustomItem):

    def __init__(self, x, y, width, height, line_width, **kwargs):
        CustomItem.__init__(self, **kwargs)
        self.x = x
        self.y = y
        self.width = width
        self.height = height
        self.line_width = line_width

    def do_update(self, entire_tree, cr):
        half_lw = self.line_width/2
        self.bounds.x1 = float(self.x - half_lw)
        self.bounds.y1 = float(self.y - half_lw)
        self.bounds.x2 = float(self.x + self.width + half_lw)
        self.bounds.y2 = float(self.y + self.height + half_lw)
        return self.bounds

    def do_paint(self, cr, bounds, scale):
        cr.arc(self.x, self.y, 20, 0,360)
        cr.move_to(self.x-4,self.y+5)
        cr.show_text("G")
        cr.set_line_width(self.line_width)
        cr.set_source_rgb(0, 0, 0)
        cr.stroke()